package se.softstuff.nb.guicomponentinfodemo;

import java.io.IOException;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Locale;
import java.util.Set;
import java.util.logging.Logger;
import org.netbeans.api.autoupdate.OperationContainer;
import org.netbeans.api.autoupdate.OperationContainer.OperationInfo;
import org.netbeans.api.autoupdate.OperationException;
import org.netbeans.api.autoupdate.OperationSupport;
import org.netbeans.api.autoupdate.OperationSupport.Restarter;
import org.netbeans.api.autoupdate.UpdateElement;
import org.netbeans.api.autoupdate.UpdateManager;
import org.netbeans.api.autoupdate.UpdateUnit;
import org.openide.util.Exceptions;
import org.openide.windows.TopComponent;
import org.openide.DialogDescriptor;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.awt.Toolbar;
import org.openide.awt.ToolbarPool;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.loaders.DataFolder;
import org.openide.loaders.DataShadow;
import org.openide.util.Lookup;
import org.openide.util.editable.NbBundle;
import org.openide.windows.WindowManager;
import se.softstuff.nb.corecomponent.api.ContactPanel;

/**
 * Top component which displays some demo stuff to be localized by NbTranslator..
 */
//@ConvertAsProperties(dtd = "-//se.softstuff.nb.guicomponentinfodemo//Demo//EN",
//autostore = false)
public final class DemoTopComponent extends TopComponent {

    private static DemoTopComponent instance;

    /**
     * path to the icon used by the component and its open action
     */
    private static final String PREFERRED_ID = "DemoTopComponent";

    public DemoTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(DemoTopComponent.class, "CTL_DemoTopComponent"));
        setToolTipText(NbBundle.getMessage(DemoTopComponent.class, "HINT_DemoTopComponent"));
        addContact(new ContactPanel("Kalle", "Sweden", "08-123456", "kalle@noreply.com", true));
        addContact(new ContactPanel("Olle", "Sweden", "08-123456", "olle@noreply.com", true));
        addContact(new ContactPanel("Foo", "Sweden", "08-123456", "foo@noreply.com", true));

        String message = NbBundle.getMessage(getClass(), "DemoTopComponent.titleLabel.text");
        titleLabel.setText(message);

    }

    private void addContact(ContactPanel contact) {
        contactTabbedPane.addTab(contact.getContactName(), contact);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        titleLabel = new javax.swing.JLabel();
        contactTabbedPane = new javax.swing.JTabbedPane();
        AddButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        enableButton = new javax.swing.JButton();

        setName("Form"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(titleLabel, NbBundle.getMessage(DemoTopComponent.class, "DemoTopComponent.titleLabel.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        titleLabel.setName("titleLabel"); // NOI18N

        contactTabbedPane.setName("contactTabbedPane"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(AddButton, NbBundle.getMessage(DemoTopComponent.class, "DemoTopComponent.AddButton.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        AddButton.setName("AddButton"); // NOI18N
        AddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(removeButton, NbBundle.getMessage(DemoTopComponent.class, "DemoTopComponent.removeButton.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        removeButton.setName("removeButton"); // NOI18N
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(enableButton, NbBundle.getMessage(DemoTopComponent.class, "DemoTopComponent.enableButton.text", Locale.getDefault().getDisplayLanguage())); // NOI18N
        enableButton.setName("enableButton"); // NOI18N
        enableButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                enableButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(titleLabel))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(contactTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(153, 153, 153)
                        .addComponent(enableButton)
                        .addGap(26, 26, 26)
                        .addComponent(removeButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(AddButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(titleLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(contactTabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 222, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(AddButton)
                    .addComponent(removeButton)
                    .addComponent(enableButton))
                .addContainerGap(13, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void AddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddButtonActionPerformed

        ContactPanel contact = new ContactPanel();
        NotifyDescriptor descriptor = new DialogDescriptor(
                contact,
                NbBundle.getMessage(this.getClass(), "DemoTopComponent.AddContactDialog.title"),
                true,
                NotifyDescriptor.OK_CANCEL_OPTION,
                NotifyDescriptor.OK_OPTION,
                null);
        Object result = DialogDisplayer.getDefault().notify(descriptor);

        if (NotifyDescriptor.OK_OPTION.equals(result)) {
            addContact(contact);
        }
    }//GEN-LAST:event_AddButtonActionPerformed

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        if (contactTabbedPane.getSelectedIndex() >= 0) {
            contactTabbedPane.removeTabAt(contactTabbedPane.getSelectedIndex());
        }
    }//GEN-LAST:event_removeButtonActionPerformed

    private void enableButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_enableButtonActionPerformed

        UpdateElement translatorModule = getModule("se.softstuff.nb.nb.translator");

        Collection<UpdateElement> toDisable = getModules("se.softstuff.nb.nb.translator");

        OperationContainer oc = translatorModule.isEnabled() ? OperationContainer.createForDirectDisable() : OperationContainer.createForEnable();

        for (UpdateElement module : toDisable) {
            if (oc.canBeAdded(module.getUpdateUnit(), module)) { // check if module can be disabled
                OperationInfo operationInfo = oc.add(module);
                if (operationInfo == null) { // it means it's already planned to disable
                    continue;
                }
                // get all module depending on this module
                Set requiredElements = operationInfo.getRequiredElements();
                // add all of them between modules for disable
                oc.add(requiredElements);
            }
        }

        try {
            // get operation support for complete the disable operation
            Object support = oc.getSupport();
            OperationSupport os = (OperationSupport) support;
            Restarter restarter = os.doOperation(null);

            enableButton.setText(translatorModule.isEnabled() ? "Disable" : "Enable");
            // no restart needed in this case
            assert restarter == null;
        } catch (OperationException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_enableButtonActionPerformed

    private UpdateElement getModule(String codeName) {
        Iterator<UpdateElement> modules = getModules(codeName).iterator();
        if (modules.hasNext()) {
            return modules.next();
        }
        return null;
    }

    private Collection<UpdateElement> getModules(String... codeName) {
        Collection<String> codeNames = Arrays.asList(codeName);
        Collection<UpdateElement> modules = new HashSet();
        java.util.List<UpdateUnit> allUpdateUnits = UpdateManager.getDefault().getUpdateUnits(UpdateManager.TYPE.MODULE);
        for (UpdateUnit unit : allUpdateUnits) {
            if (unit.getInstalled() != null) { // filter all installed modules
                UpdateElement el = unit.getInstalled();
                if (codeNames.contains(el.getCodeName())) { // filter given module in the parameter
                    modules.add(el);
                    el.isEnabled();
                }
            }
        }

        return modules;
    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton AddButton;
    private javax.swing.JTabbedPane contactTabbedPane;
    private javax.swing.JButton enableButton;
    private javax.swing.JButton removeButton;
    private javax.swing.JLabel titleLabel;
    // End of variables declaration//GEN-END:variables

    /**
     * Gets default instance. Do not use directly: reserved for *.settings files
     * only, i.e. deserialization routines; otherwise you could get a
     * non-deserialized instance. To obtain the singleton instance, use
     * {@link #findInstance}.
     */
    public static synchronized DemoTopComponent getDefault() {
        return instance = new DemoTopComponent();
    }

    /**
     * Obtain the DemoTopComponent instance. Never call {@link #getDefault}
     * directly!
     */
    public static synchronized DemoTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(DemoTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof DemoTopComponent) {
            return (DemoTopComponent) win;
        }
        Logger.getLogger(DemoTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID
                + "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    public static boolean registerToolbar(String toolbarConfigPath) {
        try {
            FileObject fo = FileUtil.getConfigFile(toolbarConfigPath);
            if (fo == null) {
                return false;
            }
            DataFolder df = DataFolder.findFolder(fo);
            DataFolder target = ToolbarPool.getDefault().getFolder();
            FileObject targetFO = target.getPrimaryFile().getFileObject(fo.getNameExt() + ".shadow");

            if (df != null && targetFO == null) {
                DataShadow ds = df.createShadow(target);
                return true;
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    public static void setToolbarVisible(Toolbar toolbar, boolean visible) {
        try {
            ClassLoader cl = Lookup.getDefault().lookup(ClassLoader.class);
            Class cToolbarConfiguration = cl.loadClass("org.netbeans.core.windows.view.ui.toolbars.ToolbarConfiguration");
            // invoke static ToolbarConfiguration.findConfiguration( String name)
            Object toolbarConfig = cToolbarConfiguration.getMethod("findConfiguration", String.class).
                    invoke(cToolbarConfiguration, "Standard");
            // invoke ToolbarConfiguration#setToolbarVisible( Toolbar tb, boolean visible)
            toolbarConfig.getClass().getMethod("setToolbarVisible", Toolbar.class, boolean.class).invoke(toolbarConfig, toolbar, visible);
        } catch (Exception ex) {
            throw new IllegalArgumentException(ex);
        }

    }

    @Override
    public void componentClosed() {
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }
}
